> ## Documentation Index
> Fetch the complete documentation index at: https://developer.box.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a task

export const MultiRelatedLinks = ({sections = []}) => {
  if (!sections || sections.length === 0) {
    return null;
  }
  return <div className="space-y-8">
      {sections.map((section, index) => <RelatedLinks key={index} title={section.title} items={section.items} />)}
    </div>;
};

export const RelatedLinks = ({title, items = []}) => {
  const getBadgeClass = badge => {
    if (!badge) return "badge-default";
    const badgeType = badge.toLowerCase().replace(/\s+/g, "-");
    return `badge-${badge === "ガイド" ? "guide" : badgeType}`;
  };
  if (!items || items.length === 0) {
    return null;
  }
  return <div className="my-8">
      {}
      <h3 className="text-sm font-bold uppercase tracking-wider mb-4">{title}</h3>

      {}
      <div className="flex flex-col gap-3">
        {items.map((item, index) => <a key={index} href={item.href} className="py-2 px-3 rounded related_link hover:bg-[#f2f2f2] dark:hover:bg-[#111827] flex items-center gap-3 group no-underline hover:no-underline border-b-0">
            {}
            <span className={`px-2 py-1 rounded-full text-xs font-semibold uppercase tracking-wide flex-shrink-0 ${getBadgeClass(item.badge)}`}>
              {item.badge}
            </span>

            {}
            <span className="text-base">{item.label}</span>
          </a>)}
      </div>
    </div>;
};

export const Link = ({href, children, className, ...props}) => {
  const localizedHref = href;
  return <a href={localizedHref} className={className} {...props}>
      {children}
    </a>;
};

To create a task, you will need to provide the <Link href="/reference/post-tasks">`POST /tasks`</Link> API
with the `action` for the task, as well as an `item` to represent the file to
add the task to.

<CodeGroup>
  ```sh cURL theme={null}
  curl -i -X POST "https://api.box.com/2.0/tasks" \
       -H "authorization: Bearer <ACCESS_TOKEN>" \
       -H "content-type: application/json" \
       -d '{
         "item": {
           "id": "11446498",
           "type": "file"
         },
         "action": "review"
       }'
  ```

  ```typescript Node/TypeScript v10 theme={null}
  await client.tasks.createTask({
    item: {
      type: 'file' as CreateTaskRequestBodyItemTypeField,
      id: file.id,
    } satisfies CreateTaskRequestBodyItemField,
    message: 'test message',
    dueAt: dateTime,
    action: 'review' as CreateTaskRequestBodyActionField,
    completionRule: 'all_assignees' as CreateTaskRequestBodyCompletionRuleField,
  } satisfies CreateTaskRequestBody);
  ```

  ```python Python v10 theme={null}
  client.tasks.create_task(
      CreateTaskItem(type=CreateTaskItemTypeField.FILE, id=file.id),
      action=CreateTaskAction.REVIEW,
      message="test message",
      due_at=date_time,
      completion_rule=CreateTaskCompletionRule.ALL_ASSIGNEES,
  )
  ```

  ```csharp .NET v10 theme={null}
  await client.Tasks.CreateTaskAsync(requestBody: new CreateTaskRequestBody(item: new CreateTaskRequestBodyItemField() { Type = CreateTaskRequestBodyItemTypeField.File, Id = file.Id }) { Message = "test message", DueAt = dateTime, Action = CreateTaskRequestBodyActionField.Review, CompletionRule = CreateTaskRequestBodyCompletionRuleField.AllAssignees });
  ```

  ```swift Swift v10 theme={null}
  try await client.tasks.createTask(requestBody: CreateTaskRequestBody(item: CreateTaskRequestBodyItemField(type: CreateTaskRequestBodyItemTypeField.file, id: file.id), message: "test message", dueAt: dateTime, action: CreateTaskRequestBodyActionField.review, completionRule: CreateTaskRequestBodyCompletionRuleField.allAssignees))
  ```

  ```java Java v10 theme={null}
  client.getTasks().createTask(new CreateTaskRequestBody.Builder(new CreateTaskRequestBodyItemField.Builder().id(file.getId()).type(CreateTaskRequestBodyItemTypeField.FILE).build()).action(CreateTaskRequestBodyActionField.REVIEW).message("test message").dueAt(dateTime).completionRule(CreateTaskRequestBodyCompletionRuleField.ALL_ASSIGNEES).build())
  ```

  ```java Java v5 theme={null}
  BoxFile file = new BoxFile(api, "id");
  Date dueAt = new Date();
  file.addTask(BoxTask.Action.REVIEW, "Please review this file.", dueAt);
  ```

  ```py Python v4 theme={null}
  message = 'Please review this'
  due_at = "2014-04-03T11:09:43-07:00"
  task = client.file(file_id='11111').create_task(message, due_at)
  print(f'Task message is {task.message} and it is due at {task.due_at}')
  ```

  ```csharp .NET v6 theme={null}
  var taskParams = new BoxTaskCreateRequest()
  {
      Item = new BoxRequestEntity()
      {
          Type = BoxType.file,
          Id = "11111"
      },
      Message = "Please review!"
  };
  BoxTask task = await client.TasksManager.CreateTaskAsync(taskParams);
  ```

  ```js Node v4 theme={null}
  var options = {
   message: 'Please review for publication!',
   due_at: '2014-04-03T11:09:43-07:00'
  };
  client.tasks.create('22222', options)
   .then(task => {
    /* task -> {
     type: 'task',
     id: '11111',
     item: 
     { type: 'file',
      id: '22222',
      sequence_id: '0',
      etag: '0',
      sha1: '0bbd79a105c504f99573e3799756debba4c760cd',
      name: 'box-logo.png' },
     due_at: '2014-04-03T11:09:43-07:00',
     action: 'review',
     message: 'Please review for publication!',
     task_assignment_collection: { total_count: 0, entries: [] },
     is_completed: false,
     created_by: 
     { type: 'user',
      id: '33333',
      name: 'Example User',
      login: 'user@example.com' },
     created_at: '2013-04-03T11:12:54-07:00' }
    */
   });
  ```
</CodeGroup>

## Task actions

Box currently supports two types of tasks defined by the `action` value:
`review` tasks and `complete` tasks.

The type of task determines the possible resolution states a task can be in and
the interface shown to a user in the web and mobile apps.

| Task action | Possible resolution states           |
| ----------- | ------------------------------------ |
| `review`    | `incomplete`, `approved`, `rejected` |
| `complete`  | `incomplete`, `complete`             |

A `review` task starts out in an `incomplete` state and can be marked as
`incomplete`, `approved`, or `rejected`. In the user interface a user is
provided with a text box and an pair of buttons to approve or reject the task.

A `complete` task starts out in an `incomplete` state and can be marked
`incomplete` or `completed`. Once a this task is marked completed, no
further changes can be made to the task's state. In the user interface a user is
provided with a text box and an button to mark the task as completed.

## Completion rules

A task on a file can be assigned to more than one collaborator on the file, and
a task has a `completion_rule` that can be used to define if all users who've
been assigned the task (`all_assignees`) or only one assignee (`any_assignee`)
need to complete the task.

<RelatedLinks
  title="RELATED APIS"
  items={[
{ label: translate("Create task"), href: "/reference/post-tasks", badge: "POST" }
]}
/>

<RelatedLinks
  title="RELATED GUIDES"
  items={[
{ label: translate("Lists all tasks for a file"), href: "/guides/tasks/for-file", badge: "GUIDE" },
{ label: translate("Get information about a task"), href: "/guides/tasks/get", badge: "GUIDE" },
{ label: translate("Make changes to an existing task"), href: "/guides/tasks/update", badge: "GUIDE" }
]}
/>
